// ABFtoQDF.cpp : Convert ABF file to QDF file
#include "stdafx.h"
#include "ABFtoQDF.h"

char bufLong[_MAX_PATH];
char bufShort[_MAX_PATH];

CDlgCheck g_chkSubtract;
CDlgEdit g_edtSelectedTraces;
CDlgControl g_spinTrace;
CDlgControl g_lblTraceNumber;
CDlgButton g_btnIncludeTrace;
CDlgButton g_btnPreview;
CDlgControl g_picTrace;

int * g_aiTrace = NULL;
int g_iTrace=0, g_iTraces=1;
double g_dMin, g_dMax;

RECT g_rctPic;
ABFFileHeader g_abfFH;
bool g_bOpened=false;

//----- Message handler for Convert dialogue
void ABFError( int nError ) { 
	#ifdef _DEBUG
	char bufErr[256];							
	ABF_BuildErrorText( nError, bufLong, bufErr, 255 );							
	OutputDebugString( bufErr );
	#endif
	}

//----- Fill in "trace 0 of 1" text label
void SetTraceLabelText() { 
	char buf[100];
	sprintf( buf, "Spin %d of %d", g_iTrace, g_iTraces );
	g_lblTraceNumber.SetText( buf );
	};
	
//-----
void LoadTrace( int iTrace ) { 
	g_iTrace=iTrace;
	if( g_iTrace>=0 && g_iTrace<g_iTraces && g_bOpened ) { 
		//TODO 
		}
	}

/*
//----- Open Selected abf file 
bool OpenAbf( ABFFileHeader * pFile ) { 
	} 
*/

//----- Turn on/off preview mode 
void Preview( bool bOn ) { 
/*	
	if( bOn ) { 
		//-- close file if already opened
		if( g_bOpened ) { 
			ABF_Close( g_abfFH, NULL );
			g_bOpened=false;
			}


		//-- attempt to open file 
		
					bool bReadChErr = false;
					char buf[256];
					SetWindowText( hDlg, "Converting file...");
					//-----------------------------------------------------------------
					//-- open source file 
					GetWindowText( GetDlgItem(hDlg,IDC_EDT_ABF), bufLong, _MAX_PATH );	
					
					int hFile=0;
					int nError;
					unsigned int iMaxSamples;
					DWORD dwMaxEpi;
					ABFFileHeader abfFH;
					if( ! ABF_ReadOpen( bufLong, &hFile, ABF_DATAFILE, &abfFH, &iMaxSamples, &dwMaxEpi, &nError ) ) {
						SetWindowText( hDlg, "Error opening source file!");
						return -1;		// TODO - error 
						}
					int iChannels = abfFH.nADCNumChannels;
					
					//-- Create Data object 
					CData oData;
					//-- add channels 
					for( int iCh=0; iCh<iChannels; ++iCh ) { 
						if( ! oData.m_oConfig.AddChannel( true ) ) 
							iChannels=iCh;
						else { 
							CChannel * pChannel = oData.m_oConfig.Channel( iCh );
							pChannel->m_cName = CString( abfFH.sADCChannelName[iCh], 10 );
							pChannel->m_cUnits = CString( abfFH.sADCUnits[iCh], 8 );
							}
						}

					//-- Add stimulus channel 
					BOOL bStim = (abfFH.nDigitalDACChannel==0);	//TODO - how is this correctly determined ? 
					int iTotalChannels = iChannels+(bStim?1:0);

					if( bStim ) { 
						if( oData.m_oConfig.AddChannel( true ) )  { 
							CChannel * pChannel = oData.m_oConfig.Channel( iCh );
							pChannel->m_cName = CString( abfFH.sDACChannelName[0], 10 );
							pChannel->m_cUnits = CString( abfFH.sDACChannelUnits[0], 8 );
							
							}
						else 
							bStim=FALSE;
						}
					
					//-- 
					UINT iSamples, iSampRead;

					int iAlloc=1500000;									// data buffer - grow if necc.
					float * pf = new float[ iTotalChannels*iAlloc ];
					if( pf==NULL ) {
						ABF_Close( hFile, NULL );
						SetWindowText( hDlg, "Error allocating!");
						return -1;	//TODO - error message
						}
					
					
					//-- For each episode
					for( DWORD dwEpi=1; dwEpi<=dwMaxEpi; ++dwEpi ) {
						sprintf( buf, "Converting file... %d of %d episodes.", int(dwEpi), int(dwMaxEpi) );
						SetWindowText( hDlg, buf );
						
						//-- query size of episode
						ABF_GetNumSamples( hFile, &abfFH, dwEpi, &iSamples, &nError ) ;
							
						//-- expand buffer if not large enough
						if( iSamples > UINT(iAlloc) ) {					// too much data - grow buffer
							delete [] pf;
							iAlloc=iSamples;
							pf = new float[ iTotalChannels*iAlloc ];
							if( pf==NULL ) {
								ABF_Close( hFile, NULL );
								SetWindowText( hDlg, "Error allocating" );
								return -1;
								}
							}
							
						//-- read all channels 
						for( int iCh=0; iCh<iChannels; ++iCh )
							if( ! ABF_ReadChannel( hFile, &abfFH, iCh, dwEpi, pf+iCh*iSamples, &iSampRead, &nError ) ) {
								ABFError( nError );
								SetWindowText( hDlg, "Error reading channel." );
								if( iCh>1 ) {
									iChannels=iCh; 
									if( ! bReadChErr ) 
										MessageBox( NULL, "Not all channels can be read.", "ABF_ReadChannel", MB_OK );
									bReadChErr = true;
									}
								else 
									return -1;	//TODO - error message
								}
						
						//-- Read stimulus 
						if( bStim ) 
							if( ! ABF_GetWaveform( hFile, &abfFH, 0, dwEpi, pf+iChannels*iSamples, &nError ) ) { 
								ABFError( nError );
								SetWindowText( hDlg, "Error reading stimulus." );
								bStim=FALSE;
								}
							
						//-- add to data file 
						CSegment * pSegment = new CSegment;				// create a segment to store data 
						oData.m_aSegments.AddItem( pSegment );
						pSegment->m_iChannels = iTotalChannels;
						pSegment->m_iSamples = iSamples;
						if( ! pSegment->AllocateData( false ) ) {
							SetWindowText( hDlg, "Error Allocating!" );
							return -1;	
							}
						for( unsigned int i=0; i<iTotalChannels*iSamples; ++i )		// convert floats to doubles
							pSegment->m_pdData[i] = pf[i];
						}
					delete [] pf;
		g_iTrace=0;
		g_iTraces=10;
		SendMessage( g_spinTrace.GetHandle(), UDM_SETRANGE, 0, MAKELONG( g_iTraces, 0 ) );
		SendMessage( g_spinTrace.GetHandle(), UDM_SETPOS, 0, MAKELONG( 0, 0 ) );
	
		//TODO 
		g_spinTrace.SetEnabled(true);
		g_btnIncludeTrace.SetEnabled(true);
		g_btnPreview.SetEnabled(true);
		}
	else { 
		if( g_bOpened ) { 
			ABF_Close( g_abfFH, NULL );
			g_bOpened=false;;
			}
		g_iTrace=g_iTraces=0;
		g_spinTrace.SetEnabled(false);
		g_btnIncludeTrace.SetEnabled(false);
		g_btnPreview.SetEnabled(false);
		}
*/
	}

//----- Message handler
LRESULT CALLBACK Convert(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) {
	switch (message) {
		case WM_INITDIALOG : {				//----- Set control handles
			#ifdef _DEBUG
				SetWindowText( GetDlgItem(hDlg,IDC_EDT_ABF), "C:\\Temp\\08310002c.abf" );
				SetWindowText( GetDlgItem(hDlg,IDC_EDT_QDF), "C:\\Temp\\08310002c.qdf" );
			#endif
			//-- set control handles
			g_chkSubtract.SetHandle( GetDlgItem(hDlg,IDC_CHKSUBTRACT), "Set to use average of selected traces as baseline to be subtracted from all traces." );
			g_edtSelectedTraces.SetHandle( GetDlgItem(hDlg,IDC_EDTSELECTEDTRACES), "Comma separated list of trace numbers to use as baseline" );
			g_spinTrace.SetHandle( GetDlgItem(hDlg,IDC_SPINTRACE), "Change visible trace in preview box" );
			g_lblTraceNumber.SetHandle( GetDlgItem(hDlg,IDC_LBLTRACENUMBER), "Current visible trace" );
			g_btnIncludeTrace.SetHandle( GetDlgItem(hDlg,IDC_BTNINCLUDETRACE), "Add current trace to list of baseline traces" );
			g_btnPreview.SetHandle( GetDlgItem(hDlg,IDC_BTNPREVIEW), "Preview average of traces." );
			g_picTrace.SetHandle( GetDlgItem(hDlg,IDC_PICTRACE), "Display current trace." );
			
			//===== TODO hide these until implemented someday
			g_chkSubtract.SetVisible(false);
			g_edtSelectedTraces.SetVisible(false);
			g_spinTrace.SetVisible(false);
			g_lblTraceNumber.SetVisible(false);
			g_btnIncludeTrace.SetVisible(false);
			g_btnPreview.SetVisible(false);
			g_picTrace.SetVisible(false);
			
			//-- set up array of high low for pic display - initially a simple pattern
			g_picTrace.GetControlOffsetBounds( &g_rctPic );
			int iWidth = g_rctPic.right-g_rctPic.left;
			g_aiTrace = new int[ iWidth*2 ];
			for( int i=0; i<iWidth; ++i ) { 
				g_aiTrace[i*2]=10+i%7;
				g_aiTrace[i*2+1]=15+i%11;
				}
			}
			return TRUE;

		case WM_NOTIFY: {					//----- Change selected trace with spin control
			int wmId = LOWORD(wParam); 
			if( wmId == IDC_SPINTRACE ) {
				if( ((LPNMUPDOWN) lParam)->iDelta == 1 ) 
					g_iTrace = min( g_iTrace+1, g_iTraces ); 
				if( ((LPNMUPDOWN) lParam)->iDelta == -1 ) 
					g_iTrace = max( g_iTrace-1, 1 ); 
				SetTraceLabelText();
				}
			break;
			}
		
		case WM_PAINT:						//----- Draw selected trace
			/*
			if( g_aiTrace != NULL ) {
				HDC hdc = GetWindowDC( hDlg );
				int iWidth = g_rctPic.right-g_rctPic.left;
				int iHeight = g_rctPic.bottom-g_rctPic.top;
				for( int i=0; i<iWidth; ++i ) { 
					MoveToEx( hdc, g_rctPic.left+i, g_rctPic.top+g_aiTrace[i*2], NULL );
					LineTo( hdc, g_rctPic.left+i, g_rctPic.top+g_aiTrace[i*2+1] );
					}
				ReleaseDC( hDlg, hdc );
				}
			*/
			break;
			
		case WM_COMMAND:
			switch LOWORD(wParam) { 
				case IDC_SELABF :			//----- Browse [...] button for abf file 
					GetWindowText( GetDlgItem(hDlg,IDC_EDT_ABF), bufLong, _MAX_PATH );	
					if( GetOpenFileName( bufLong, "Axon Files(*.abf)\0*.abf\0\0", "abf", hDlg, bufShort ) ) 
						SetWindowText( GetDlgItem(hDlg,IDC_EDT_ABF), bufLong );
					break;
					
				case IDC_SELQDF :			//----- Browse [...] button for qdf file 
					GetWindowText( GetDlgItem(hDlg,IDC_EDT_QDF), bufLong, _MAX_PATH );	
					if( GetOpenFileName( bufLong, "QUB Files(*.qdf)\0*.qdf\0\0", "qdf", hDlg, bufShort ) ) 
						SetWindowText( GetDlgItem(hDlg,IDC_EDT_QDF), bufLong );
					break;
					
				case IDC_CHKSUBTRACT :		//----- Toggle trace preview mode
					Preview( g_chkSubtract.GetCheck() );	// On(Open abf file, get count of traces) or off(close abf file).
					break;
					
				case IDC_BTNINCLUDETRACE : //----- add current trace to list of traces
					g_lblTraceNumber.SetText("Test include trace");	//TODO
					break;

				case IDC_BTNPREVIEW :		//----- display preview of average trace
					g_lblTraceNumber.SetText("Test preview");	//TODO
					break;

				case IDOK : {				//----- Run data conversion 
					Preview(false);
					
					bool bReadChErr = false;
					char buf[256];
					SetWindowText( hDlg, "Converting file...");
					//-----------------------------------------------------------------
					//-- open source file 
					GetWindowText( GetDlgItem(hDlg,IDC_EDT_ABF), bufLong, _MAX_PATH );	
					
					int hFile=0;
					int nError;
					unsigned int iMaxSamples;
					DWORD dwMaxEpi;
					ABFFileHeader abfFH;
					if( ! ABF_ReadOpen( bufLong, &hFile, ABF_DATAFILE, &abfFH, &iMaxSamples, &dwMaxEpi, &nError ) ) {
						SetWindowText( hDlg, "Error opening source file!");
						return -1;		// TODO - error 
						}
					int iChannels = abfFH.nADCNumChannels;
					
					//-- Create Data object 
					CData oData;
					//-- add channels 
					for( int iCh=0; iCh<iChannels; ++iCh ) { 
						if( ! oData.m_oConfig.AddChannel( true ) ) 
							iChannels=iCh;
						else { 
							CChannel * pChannel = oData.m_oConfig.Channel( iCh );
							pChannel->m_cName = CString( abfFH.sADCChannelName[iCh], 10 );
							pChannel->m_cUnits = CString( abfFH.sADCUnits[iCh], 8 );
							}
						}

					//-- Add stimulus channel 
					BOOL bStim = (abfFH.nDigitalDACChannel==0);	//TODO - how is this correctly determined ? 
					int iTotalChannels = iChannels+(bStim?1:0);

					if( bStim ) { 
						if( oData.m_oConfig.AddChannel( true ) )  { 
							CChannel * pChannel = oData.m_oConfig.Channel( iCh );
							pChannel->m_cName = CString( abfFH.sDACChannelName[0], 10 );
							pChannel->m_cUnits = CString( abfFH.sDACChannelUnits[0], 8 );
							
							}
						else 
							bStim=FALSE;
						}
					
					//-- 
					UINT iSamples, iSampRead;

					int iAlloc=1500000;									// data buffer - grow if necc.
					float * pf = new float[ iTotalChannels*iAlloc ];
					if( pf==NULL ) {
						ABF_Close( hFile, NULL );
						SetWindowText( hDlg, "Error allocating!");
						return -1;	//TODO - error message
						}
					
					
					//-- For each episode
					for( DWORD dwEpi=1; dwEpi<=dwMaxEpi; ++dwEpi ) {
						sprintf( buf, "Converting file... %d of %d episodes.", int(dwEpi), int(dwMaxEpi) );
						SetWindowText( hDlg, buf );
						
						//-- query size of episode
						ABF_GetNumSamples( hFile, &abfFH, dwEpi, &iSamples, &nError ) ;
							
						//-- expand buffer if not large enough
						if( iSamples > UINT(iAlloc) ) {					// too much data - grow buffer
							delete [] pf;
							iAlloc=iSamples;
							pf = new float[ iTotalChannels*iAlloc ];
							if( pf==NULL ) {
								ABF_Close( hFile, NULL );
								SetWindowText( hDlg, "Error allocating" );
								return -1;
								}
							}
							
						//-- read all channels 
						for( int iCh=0; iCh<iChannels; ++iCh )
							if( ! ABF_ReadChannel( hFile, &abfFH, iCh, dwEpi, pf+iCh*iSamples, &iSampRead, &nError ) ) {
								ABFError( nError );
								SetWindowText( hDlg, "Error reading channel." );
								if( iCh>1 ) {
									iChannels=iCh; 
									if( ! bReadChErr ) 
										MessageBox( NULL, "Not all channels can be read.", "ABF_ReadChannel", MB_OK );
									bReadChErr = true;
									}
								else 
									return -1;	//TODO - error message
								}
						
						//-- Read stimulus 
						if( bStim ) 
							if( ! ABF_GetWaveform( hFile, &abfFH, 0, dwEpi, pf+iChannels*iSamples, &nError ) ) { 
								ABFError( nError );
								SetWindowText( hDlg, "Error reading stimulus." );
								bStim=FALSE;
								}
							
						//-- add to data file 
						CSegment * pSegment = new CSegment;				// create a segment to store data 
						oData.m_aSegments.AddItem( pSegment );
						pSegment->m_iChannels = iTotalChannels;
						pSegment->m_iSamples = iSamples;
						if( ! pSegment->AllocateData( false ) ) {
							SetWindowText( hDlg, "Error Allocating!" );
							return -1;	
							}
						for( unsigned int i=0; i<iTotalChannels*iSamples; ++i )		// convert floats to doubles
							pSegment->m_pdData[i] = pf[i];
						}
					delete [] pf;
						
					//-- Close ABF 			
					ABF_Close( hFile, NULL );

					//-- Write QDF 
					GetWindowText( GetDlgItem(hDlg,IDC_EDT_QDF), bufLong, _MAX_PATH );	

					oData.m_dScaling=1.0;
					oData.m_dSampling=abfFH.fADCSequenceInterval/1000000;	// * pFH.nADCNumChannels
					if( ! oData.WriteQDF( bufLong ) ) {
						SetWindowText( hDlg, "Error writing .QDF file !" );
						return -1;	//TODO - error message
						}
						
					SetWindowText( hDlg, "Conversion complete." );
					}
				
				case IDCANCEL : 
					if( g_aiTrace != NULL ) 
						delete [] g_aiTrace;
					EndDialog(hDlg, LOWORD(wParam));
					break;
				}
			break;
		}
	return FALSE;
	}

//---------- Main 
int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow ) {
	DialogBox( hInstance, (LPCTSTR)IDD_CONVERT, NULL, (DLGPROC)Convert);
	return 0;
	}

